SystemOrganization addCategory: #'Xpf-Models'!
SystemOrganization addCategory: #'Xpf-Models-Tests'!

Object subclass: #TestFoo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Models'!

!TestFoo methodsFor: 'as yet unclassified' stamp: 'topa 12/16/2009 12:27'!
test

	| t | 
	Transcript show: 'a'.
	t := [
		Transcript show: 'b'.
		'c'
	] ensure: [
		Transcript show: 'd'.
		Transcript show: t. "t = nil => return"
	].
	Transcript show: t.  "t notNil => no retrun"
	Transcript show: 'e'.! !

Object subclass: #XpfTestData
	instanceVariableNames: 'testProject testUser testUser2 testIteration testIteration2 testStory testTask testTask2 testStory2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Models-Tests'!

!XpfTestData methodsFor: 'initialization' stamp: 'topa 12/7/2009 15:48'!
initialize

	testUser := XpfUser new
		login: 'testUser';
		userName: 'TestUser';
		password: 'foobar'.
	testUser2 := XpfUser new
		login: 'testUser2';
		password: 'foobar2'.
	testProject := XpfProject new title: 'Test Project'.

	testIteration := XpfIteration new title: 'Test Iteration'.
	testIteration2 := XpfIteration new title: 'Test Iteration2'.
	testStory := XpfUserStory new title: 'Test UserStory'.
	testStory2 := XpfUserStory new title: 'Test UserStory 2'.
	testTask := XpfTask new
		title: 'Test Task';
		timeEstimated: 12;
		timeActual: 15.
	testTask2 := XpfTask new
		title: 'Test Task 2'.
	testProject addIteration: testIteration.
	testIteration addUserStory: testStory.
	XpfIteration new addUserStory: testStory2.
	testStory addTask: testTask.
	testProject addDeveloper: testUser.! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:28'!
testIteration

	^ testIteration! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 18:25'!
testIteration2

	^ testIteration2! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 18:25'!
testIteration2: anObject

	testIteration2 := anObject.! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:28'!
testIteration: anObject

	testIteration := anObject.! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:28'!
testProject

	^ testProject! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:28'!
testProject: anObject

	testProject := anObject.! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:28'!
testStory

	^ testStory! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 18:59'!
testStory2

	^ testStory2! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 18:59'!
testStory2: anObject

	testStory2 := anObject.! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:28'!
testStory: anObject

	testStory := anObject.! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:28'!
testTask

	^ testTask! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 18:27'!
testTask2

	^ testTask2! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 18:27'!
testTask2: anObject

	testTask2 := anObject.! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:28'!
testTask: anObject

	testTask := anObject.! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:28'!
testUser

	^ testUser! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:28'!
testUser2

	^ testUser2! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:28'!
testUser2: anObject

	testUser2 := anObject.! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:28'!
testUser: anObject

	testUser := anObject.! !

BorderedMorph subclass: #XpfEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Models'!

!XpfEntity commentStamp: 'mt 2/12/2009 12:20' prior: 0!
I am the abstract superclass of all entities in the system. These entities could be user stories, tasks, developers, themes, ...!

!XpfEntity class methodsFor: 'instance creation' stamp: 'topa 12/7/2009 14:11'!
dictionaryClass

	^ Smalltalk at: #StringKeyValueDictionary ifAbsent: [Dictionary]! !

!XpfEntity methodsFor: 'testing' stamp: 'topa 3/24/2009 17:27'!
isXpfEntity

	^ true! !

XpfEntity subclass: #XpfIteration
	instanceVariableNames: 'project title userStories timeIdeal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Models'!

XpfIteration subclass: #XpfFutureIteration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Models'!

!XpfFutureIteration methodsFor: 'testing' stamp: 'topa 3/24/2009 17:18'!
isXpfFutureIteration

	^ true! !

!XpfFutureIteration methodsFor: 'accessing' stamp: 'topa 4/7/2009 14:12'!
moveNilUserStoriesToFuture
	
	self project userStories do: [:us | 
		us iteration ifNil: [self addUserStory: us]].! !

!XpfFutureIteration methodsFor: 'accessing' stamp: 'SR 4/12/2009 21:15'!
timeIdeal

	^ 0! !

!XpfFutureIteration methodsFor: 'accessing' stamp: 'SR 4/12/2009 21:15'!
timeIdeal: anObject

	^ self! !

!XpfFutureIteration methodsFor: 'accessing' stamp: 'mfp 4/28/2009 11:50'!
title

	^ 'Open Stories'! !

!XpfFutureIteration methodsFor: 'accessing' stamp: 'topa 4/7/2009 14:14'!
title: aString
	"rest and GemStone compatibility"
	
	^ self! !

!XpfIteration class methodsFor: 'as yet unclassified' stamp: 'SR 3/25/2009 18:13'!
newFrom: aDictionary

	^ self new title: (aDictionary at: 'title' ifAbsent: [])! !

!XpfIteration methodsFor: 'add-remove' stamp: 'SR 3/25/2009 18:15'!
addNewUserStory: aDictionary

	^ self addUserStory: (XpfUserStory newFrom: aDictionary)! !

!XpfIteration methodsFor: 'add-remove' stamp: 'topa 12/14/2009 14:21'!
addUserStory: aUserStory

	aUserStory iteration ifNotNil:
		[aUserStory iteration removeUserStory: aUserStory].
	aUserStory iteration: self.
	(self userStories includes: aUserStory) ifFalse: 
		[self userStories add: aUserStory].

	self addMorph: aUserStory.

	^ aUserStory		! !

!XpfIteration methodsFor: 'deleting' stamp: 'topa 12/7/2009 13:29'!
delete

	self userStories do: [:us | us delete].
	super delete.
! !

!XpfIteration methodsFor: 'initialization' stamp: 'topa 12/14/2009 14:31'!
initialize

	super initialize.
	self userStories: OrderedCollection new.
	
	self 
		extent: 300 @ 400;
		color: Color lightGreen lighter.! !

!XpfIteration methodsFor: 'accessing' stamp: 'SR 4/7/2009 11:15'!
isXpfFutureIteration

	^ false! !

!XpfIteration methodsFor: 'printing' stamp: 'SR 3/20/2009 20:56'!
printString

	^ self title ifNil: ['No Title']! !

!XpfIteration methodsFor: 'accessing' stamp: 'SR 4/7/2009 11:15'!
project

	^ project! !

!XpfIteration methodsFor: 'accessing' stamp: 'topa 12/7/2009 13:26'!
project: anObject

	project := anObject.! !

!XpfIteration methodsFor: 'private' stamp: 'topa 12/14/2009 14:23'!
removeUserStory: aUserStory 

	(self userStories noneSatisfy: [:us | us = aUserStory]) ifTrue: [^ aUserStory].
	self userStories remove: aUserStory.
	aUserStory iteration: nil.

	self removeMorph: aUserStory.
	^ aUserStory! !

!XpfIteration methodsFor: 'accessing' stamp: 'SR 4/12/2009 21:15'!
timeIdeal

	^ timeIdeal! !

!XpfIteration methodsFor: 'accessing' stamp: 'SR 4/12/2009 21:15'!
timeIdeal: anObject

	timeIdeal := anObject! !

!XpfIteration methodsFor: 'accessing' stamp: 'topa 12/27/2009 13:10'!
title

	<bindable>
	^ title! !

!XpfIteration methodsFor: 'accessing' stamp: 'topa 12/7/2009 13:28'!
title: anObject

	anObject = self title ifTrue: [^ self].
	title := anObject.! !

!XpfIteration methodsFor: 'accessing' stamp: 'topa 12/7/2009 13:27'!
userStories

	^ userStories! !

!XpfIteration methodsFor: 'accessing' stamp: 'topa 12/7/2009 13:27'!
userStories: anObject

	userStories := anObject.! !

XpfEntity subclass: #XpfProject
	instanceVariableNames: 'title developers iterations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Models'!

!XpfProject class methodsFor: 'instance creation' stamp: 'SR 3/25/2009 18:08'!
newFrom: aDictionary

	^ self new title: (aDictionary at: 'title')! !

!XpfProject methodsFor: 'add-remove' stamp: 'topa 12/14/2009 14:22'!
addDeveloper: aUser

	(self developers anySatisfy: [:d | d = aUser])
		ifTrue: [^ aUser].
	self developers add: aUser.
	aUser addProject: self.
	
	self addMorph: aUser.


	^ aUser! !

!XpfProject methodsFor: 'add-remove' stamp: 'topa 12/14/2009 14:23'!
addIteration: anIteration

	(anIteration isXpfFutureIteration or: [self iterations includes: anIteration]) 
		ifTrue: [^ anIteration].
	self iterations add: anIteration before: (self iterations last).
	anIteration project: self.
	
	self addMorph: anIteration.

	^ anIteration! !

!XpfProject methodsFor: 'add-remove' stamp: 'SR 3/25/2009 18:13'!
addNewIteration: aDictionary

	^ self addIteration: (XpfIteration newFrom: aDictionary)! !

!XpfProject methodsFor: 'deleting' stamp: 'mt 4/16/2009 11:36'!
delete
	
	self iterations do: [:iter | iter delete].
	super delete.! !

!XpfProject methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:07'!
developers

	^ developers! !

!XpfProject methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:09'!
developers: anObject

	developers := anObject.! !

!XpfProject methodsFor: 'initialization' stamp: 'topa 12/14/2009 14:30'!
initialize

	super initialize.
	self
		iterations: (OrderedCollection with: (XpfFutureIteration new project: self));
		developers: OrderedCollection new.

	self 
		extent: 500 @ 400;
		color: Color veryVeryLightGray lighter.! !

!XpfProject methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:10'!
iterations

	^ iterations! !

!XpfProject methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:11'!
iterations: anObject

	iterations := anObject.! !

!XpfProject methodsFor: 'printing' stamp: 'mt 2/25/2009 10:16'!
printString

	^ self title ifNil: ['No Title']! !

!XpfProject methodsFor: 'add-remove' stamp: 'topa 12/14/2009 14:24'!
removeDeveloper: aUser

	self developers 
		remove: aUser
		ifAbsent: [^ aUser].
	aUser removeProject: self.
	
	self removeMorph: aUser.
	^ aUser! !

!XpfProject methodsFor: 'add-remove' stamp: 'topa 12/14/2009 14:24'!
removeIteration: anIteration

	self iterations 
		remove: anIteration
		ifAbsent: [^ anIteration].
	anIteration removeProject: self.
	
	self removeMorph: anIteration.
	^ anIteration! !

!XpfProject methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:24'!
title

	^ title! !

!XpfProject methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:11'!
title: anObject

	anObject = self title ifTrue: [^ self].
	title := anObject.! !

XpfEntity subclass: #XpfTask
	instanceVariableNames: 'title userStory timeEstimated timeActual developers isDone responsibleDeveloper isStarted lastStarted startTimes stopTimes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Models'!

!XpfTask commentStamp: 'mt 2/12/2009 12:22' prior: 0!
I am a task in tems of Extreme Programming.!

!XpfTask class methodsFor: 'instance creation' stamp: 'mt 4/15/2009 16:58'!
newFrom: aDictionary

	^ self new
		title: (aDictionary at: 'title' ifAbsent: []);
		timeActual: (aDictionary at: 'timeActual' ifAbsent: []);
		timeEstimated: (aDictionary at: 'timeEstimated' ifAbsent: []);
		isDone: (aDictionary at: 'isDone' ifAbsent: [false])! !

!XpfTask methodsFor: 'add-remove' stamp: 'topa 12/14/2009 14:25'!
addDeveloper: aUser

	(self developers anySatisfy: [:d | d = aUser])
		ifTrue: [^ aUser].
	self developers add: aUser.
	aUser addTask: self.
	
	self addMorph: aUser.
	^ aUser! !

!XpfTask methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:16'!
developers

	^ developers! !

!XpfTask methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:16'!
developers: anObject

	developers := anObject.! !

!XpfTask methodsFor: 'initialization' stamp: 'topa 12/14/2009 14:32'!
initialize

	super initialize.
	self developers: OrderedCollection new.
	
		
	self 
		extent: 40 @ 20;
		color: Color lightBlue lighter.! !

!XpfTask methodsFor: 'accessing' stamp: 'test 4/16/2009 13:36'!
isDone

	^ isDone ifNil: [isDone := false]! !

!XpfTask methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:16'!
isDone: anObject

	anObject = self isDone ifTrue: [^ self].
	self isDone & self isStarted ifTrue: [self isStarted: false].
	isDone := anObject.! !

!XpfTask methodsFor: 'accessing' stamp: 'cs 4/23/2009 13:41'!
isStarted

	^ isStarted ifNil: [isStarted := false]! !

!XpfTask methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:17'!
isStarted: anObject

	anObject = self isStarted ifTrue: [^ self].
	(self isStarted not & anObject) ifTrue: [self startWork].
	(self isStarted & anObject not) ifTrue: [self stopWork].
	isStarted := anObject.! !

!XpfTask methodsFor: 'accessing' stamp: 'cs 4/23/2009 13:49'!
lastStarted

	^ lastStarted! !

!XpfTask methodsFor: 'accessing' stamp: 'cs 4/23/2009 13:49'!
lastStarted: anObject

	lastStarted := anObject.! !

!XpfTask methodsFor: 'add-remove' stamp: 'topa 12/14/2009 14:25'!
removeDeveloper: aUser

	self pvtDevelopers 
		remove: aUser
		ifAbsent: [^ aUser].
	aUser removeTask: self.

	self removeMorph: aUser.
	^ aUser! !

!XpfTask methodsFor: 'accessing' stamp: 'SR 4/10/2009 15:07'!
responsibleDeveloper

	^ responsibleDeveloper! !

!XpfTask methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:17'!
responsibleDeveloper: anObject

	anObject = self responsibleDeveloper ifTrue: [^ self].
	responsibleDeveloper := anObject.
	self addDeveloper: anObject.! !

!XpfTask methodsFor: 'accessing' stamp: 'FHH 7/8/2009 14:21'!
startTimes
	^ startTimes ifNil: [ startTimes := SortedCollection new. ].! !

!XpfTask methodsFor: 'accessing' stamp: 'FHH 7/8/2009 14:19'!
startWork
	self timeActual ifNil: [self timeActual: 0].
	self updateStartTimesWith: DateAndTime now.! !

!XpfTask methodsFor: 'accessing' stamp: 'FHH 7/8/2009 14:21'!
stopTimes
	^ stopTimes ifNil: [ stopTimes := SortedCollection new. ].! !

!XpfTask methodsFor: 'accessing' stamp: 'FHH 7/8/2009 14:22'!
stopWork
	self updateStopTimesWith: DateAndTime now.! !

!XpfTask methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:31'!
timeActual

	^ timeActual! !

!XpfTask methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:17'!
timeActual: anObject

	anObject = self timeActual ifTrue: [^ self].
	timeActual := anObject.! !

!XpfTask methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:31'!
timeEstimated

	^ timeEstimated! !

!XpfTask methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:18'!
timeEstimated: anObject

	anObject = self timeEstimated ifTrue: [^ self].
	timeEstimated := anObject.! !

!XpfTask methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:31'!
title

	^ title! !

!XpfTask methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:21'!
title: anObject

	anObject = self title ifTrue: [^ self].
	title := anObject.! !

!XpfTask methodsFor: 'accessing' stamp: 'FHH 7/8/2009 14:21'!
updateStartTimesWith: aDateAndTime
	self startTimes add: aDateAndTime.
	self lastStarted: aDateAndTime.! !

!XpfTask methodsFor: 'accessing' stamp: 'FHH 7/8/2009 14:23'!
updateStopTimesWith: aDateAndTime
	| delta |
	self stopTimes add: aDateAndTime.
	delta := Timespan starting: self lastStarted ending: aDateAndTime.
	self timeActual: self timeActual + (delta duration asSeconds / 3600) asFloat.! !

!XpfTask methodsFor: 'accessing' stamp: 'mt 4/15/2009 16:59'!
userStory

	^ userStory! !

!XpfTask methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:21'!
userStory: anXpfUserStory

	self userStory = anXpfUserStory ifTrue: [^ anXpfUserStory].
	userStory := anXpfUserStory.
! !

XpfEntity subclass: #XpfUser
	instanceVariableNames: 'userName email projects password tasks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Models'!

!XpfUser commentStamp: 'mt 2/12/2009 12:24' prior: 0!
I am a system or application user. This could be an administrator, webmaster, developer or something like that.!

!XpfUser class methodsFor: 'authentication' stamp: 'topa 3/3/2009 22:37'!
hash: aString

	^ SecureHashAlgorithm new hashMessage: aString! !

!XpfUser class methodsFor: 'instance creation' stamp: 'SR 3/25/2009 18:01'!
newFrom: aDictionary

	^ self new
		userName: (aDictionary at: 'userName' ifAbsent: []);
		login: (aDictionary at: 'login');
		password: (aDictionary at: 'password' ifAbsent: [])! !

!XpfUser methodsFor: 'add-remove' stamp: 'topa 12/14/2009 14:27'!
addProject: aProject

	(self projects anySatisfy: [:p | p = aProject])
		ifTrue: [^ aProject].
	self projects add: aProject.
	aProject addDeveloper: self.
	
	"we dont show our Projects"
	^ aProject! !

!XpfUser methodsFor: 'add-remove' stamp: 'topa 12/14/2009 14:27'!
addTask: aTask

	(self tasks anySatisfy: [:t | t = aTask])
		ifTrue: [^ aTask].
	self tasks add: aTask.
	aTask addDeveloper: self.

	"we dont show our Tasks"
	^ aTask! !

!XpfUser methodsFor: 'authentication' stamp: 'SR 4/10/2009 12:18'!
authenticateBy: aString

	aString ifEmpty: [^ false]. "empty password is evil"
	^ self pvtPassword = (self class hash: aString)! !

!XpfUser methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:33'!
email

	^ email! !

!XpfUser methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:28'!
email: anObject

	anObject = self email ifTrue: [^ self].
	email := anObject.! !

!XpfUser methodsFor: 'initialization' stamp: 'topa 12/14/2009 14:33'!
initialize

	super initialize.
	self
		projects: OrderedCollection new;
		tasks: OrderedCollection new.
		
	self extent: 10 @ 10; color: Color red.! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 3/4/2009 14:05'!
login

	^ email! !

!XpfUser methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:30'!
login: anObject
	"You have to choose a valid email address as a login name."

	anObject = self email ifTrue: [^ self].
	self email: anObject.! !

!XpfUser methodsFor: 'accessing' stamp: 'topa 4/7/2009 14:21'!
password
	"The password is never actually returned but compared to.
	This method is necessary for rest, too."
	
	^ nil! !

!XpfUser methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:30'!
password: aString

	(aString notNil and: [(self class hash: aString) = password]) ifTrue: [^ self].
	password := aString ifNotNil: [self class hash: aString].! !

!XpfUser methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:30'!
projects

	^ projects! !

!XpfUser methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:31'!
projects: anObject

	projects := anObject.! !

!XpfUser methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:35'!
pvtPassword

	^ password! !

!XpfUser methodsFor: 'add-remove' stamp: 'topa 12/7/2009 15:31'!
removeProject: aProject

	self projects 
		remove: aProject
		ifAbsent: [^ aProject].
	aProject removeDeveloper: self.
	^ aProject! !

!XpfUser methodsFor: 'add-remove' stamp: 'topa 12/7/2009 15:31'!
removeTask: aTask

	self tasks 
		remove: aTask
		ifAbsent: [^ aTask].
	aTask removeDeveloper: self.
	^ aTask! !

!XpfUser methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:40'!
tasks

	^ tasks! !

!XpfUser methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:31'!
tasks: anObject

	tasks := anObject.! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:54'!
userName

	^ userName! !

!XpfUser methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:32'!
userName: anObject

	self userName = anObject ifTrue: [^ self].
	userName := anObject.! !

XpfEntity subclass: #XpfUserStory
	instanceVariableNames: 'title priority timeEstimated tasks timeActual iteration positionX positionY comments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Models'!

!XpfUserStory commentStamp: 'topa 2/12/2009 14:06' prior: 0!
I am a user story in terms of Extreme Programming!

!XpfUserStory class methodsFor: 'instance creation' stamp: 'topa 12/10/2009 15:53'!
newFrom: aDictionary

	^ self new
		title: (aDictionary at: 'title' ifAbsent: []);
		priority: (aDictionary at: 'priority' ifAbsent: []);
		timeEstimated: (aDictionary at: 'timeEstimated' ifAbsent: []);
		timeActual: (aDictionary at: 'timeActual' ifAbsent: [])! !

!XpfUserStory methodsFor: 'add-remove' stamp: 'SR 3/25/2009 18:00'!
addNewTask: aPropertyDictionary

	^ self addTask: (XpfTask newFrom: aPropertyDictionary)! !

!XpfUserStory methodsFor: 'add-remove' stamp: 'topa 12/14/2009 14:27'!
addTask: aTask 

	aTask userStory ifNotNil: 
		[aTask userStory removeTask: aTask].
	aTask userStory: self.
	(self tasks includes: aTask) ifFalse: 
		[self tasks add: aTask].
	
	self addMorph: aTask.
	^ aTask! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 4/30/2009 17:58'!
comments

	^ comments ifNil: [self comments: self class dictionaryClass new. comments]! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 4/30/2009 17:50'!
comments: anObject

	comments := anObject.! !

!XpfUserStory methodsFor: 'deleting' stamp: 'topa 12/7/2009 15:34'!
delete

	self tasks do: [:task | task delete].
	super delete.! !

!XpfUserStory methodsFor: 'exposing' stamp: 'AK 12/24/2009 14:10'!
exposedTitle
	"exposes the title variable"
	^self title! !

!XpfUserStory methodsFor: 'initialization' stamp: 'topa 12/14/2009 14:14'!
initialize

	super initialize.
	self 
		tasks: OrderedCollection new;
		color: Color white;
		extent: 250 @ 150.! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 3/24/2009 17:40'!
iteration

	^ iteration! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:34'!
iteration: anObject

	self iteration = anObject ifTrue: [^ self].
	iteration := anObject.! !

!XpfUserStory methodsFor: 'printing' stamp: 'mt 2/25/2009 10:21'!
printString

	^ self title ifNil: ['No Title']! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:39'!
priority

	^ priority! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:35'!
priority: anObject

	anObject = self priority ifTrue: [^ self].
	priority := anObject.! !

!XpfUserStory methodsFor: 'private' stamp: 'topa 12/14/2009 14:28'!
removeTask: aTask 

	(self tasks noneSatisfy: [:t | t = aTask]) ifTrue: [^ aTask].
	self tasks remove: aTask.
	aTask userStory: nil.
	
	self removeMorph: aTask.
	^ aTask! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:35'!
tasks

	^ tasks! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:35'!
tasks: anObject

	tasks := anObject.! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:40'!
timeActual

	^ timeActual! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:36'!
timeActual: anObject

	anObject = self timeActual ifTrue: [^ self].
	timeActual := anObject.! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:40'!
timeEstimated

	^ timeEstimated! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:36'!
timeEstimated: anObject

	anObject = self timeEstimated ifTrue: [^ self].
	timeEstimated := anObject.! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:40'!
title

	^ title! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 12/7/2009 15:36'!
title: anObject

	anObject = self title ifTrue: [^ self].
	title := anObject.! !
